<template>
    <div class="offer-wrapper">
        <div class="o-title">Special Offer</div>
        <button class="close" @click="close()"></button>
        <div class="description">
            If you would like to receive a promotion discount on our customed web solutions services, simply leave your
            email address and our sales will contact you.
        </div>
        <ValidationObserver v-slot="{ handleSubmit }" ref="form">
            <form @submit.prevent="handleSubmit(submitForm())">
                <ValidationProvider class="form-group" rules="required|email"
                                    v-slot="{ errors }">
                    <input v-model="form.email" type="email" id="offer-email"
                           :class="{'invalid': errors.length}"
                           v-typed/>
                    <label for="offer-email" class="required">Email</label>
                </ValidationProvider>
                <ValidationProvider class="form-group" :rules="{ required: { allowFalse: false } }">
                    <input v-model="form.terms" type="checkbox" id="terms"/>
                    <label for="terms">I agree to Terms & Conditions.</label>
                </ValidationProvider>
                <button type="submit" v-ripple="'rgba(84, 149, 255, 0.35)'">Submit</button>
            </form>
        </ValidationObserver>
        <Timer :starttime="startTimer"
               :endtime="endTimer"
               v-if="startTimer && endTimer"
               trans='{
                 "day":"d",
                 "hours":"h",
                 "minutes":"min",
                 "seconds":"s"
                 }'/>
        <button class="skip-offer" @click="close()">Skip Offer →</button>
    </div>
</template>

<script>
    import Timer from "./Timer";
    import {extend, ValidationObserver, ValidationProvider} from "vee-validate";
    import {email, required} from "vee-validate/dist/rules";

    extend('email', email);
    extend('required', {
        ...required
    });

    export default {
        name: "SpecialOffer",
        components: {
            ValidationProvider,
            ValidationObserver,
            Timer
        },
        data: () => ({
            startTimer: '',
            endTimer: '',
            form: {
                email: '',
                terms: false
            }
        }),
        methods: {
            close() {
                this.$modal.hide('offer')
            },
            submitForm: function () {
                this.$refs.form.validate().then(success => {
                    if (!success) {
                        return;
                    }
                    this.$http.post(process.env.VUE_APP_ENDPOINT, {...this.form}).then((resp) => {
                        console.log(resp)
                    })
                    this.$nextTick(() => {
                        this.$refs.form.reset();
                    });
                });
            }
        },
        mounted() {
            const endTime = localStorage.getItem('endTime');
            const date = new Date();
            Date.prototype.addDays = function (days) {
                var date = new Date(this.valueOf());
                date.setDate(date.getDate() + days);
                return date;
            }
            if (endTime && date.getDate() - new Date(endTime).getDate() > 0) {
                this.endTimer = endTime;
            } else {
                const date = new Date();
                this.endTimer = date.addDays(7);
                localStorage.setItem('endTime', this.endTimer);
            }
            this.startTimer = new Date();

        },
        directives: {
            typed: {
                update: function (el) {
                    el.value.trim().length ? el.classList.add('not-empty') : el.classList.remove('not-empty')
                }
            }
        }
    }
</script>

<style scoped lang="scss">
    .offer-wrapper {
        position: relative;
        max-width: 998px;
        width: 100%;
        background-color: #FFD900;
        box-shadow: 0 24px 86px rgba(#BAC3CD, .58);
        padding: 119px 20px 39px 20px;
        box-sizing: border-box;

        .o-title {
            font-family: $mainFont, sans-serif;
            font-weight: bold;
            font-size: 36px;
            color: #0F0F0F;
            letter-spacing: .8px;
            display: flex;
            align-items: center;
            justify-content: center;

            &:after {
                display: block;
                content: url("../assets/img/icons/offer.svg");
                margin-left: 5px;
            }
        }

        .close {
            position: absolute;
            top: 30px;
            right: 30px;
            width: 16px;
            height: 16px;
            background: url("../assets/img/icons/x.svg") center no-repeat;
            border: 0;

            &:hover {
                cursor: pointer;
            }
        }

        .description {
            margin: 60px auto 0 auto;
            max-width: 495px;
            font-family: $mainFont, sans-serif;
            font-weight: bold;
            font-size: 21px;
            color: #0F0F0F;
            line-height: 31px;
            letter-spacing: .8px;
        }

        form {
            display: block;
            width: 468px;
            margin: 80px auto 0 auto;

            .form-group {
                position: relative;
                margin-top: 32px;
                display: block;

                & > input[type=email] {
                    @include inputStyle(#4D4D65, #0263FF, rgba(#FF0000, .26), #FF0000, #FFD900);
                    height: 40px;
                }

                input[type=email]:focus ~ label,
                input[type=email].not-empty ~ label {
                    font-size: 10px;
                    font-weight: 700;
                    letter-spacing: 0.44px;
                    top: -10px;

                    &.required:after {
                        width: 5px;
                        height: 5px;
                        transform: translateY(-5px);
                    }
                }

                &.focus,
                &.selected {
                    label {
                        font-size: 10px;
                        font-weight: 700;
                        letter-spacing: 0.44px;
                        top: -10px;

                        &.required:after {
                            width: 5px;
                            height: 5px;
                            transform: translateY(-5px);
                        }
                    }
                }

                label {
                    @include label(#4D4D65, "../assets/img/icons/required.svg");
                }

                input[type=checkbox] {
                    display: none;

                    & + label {
                        position: relative;
                        font-size: 16px;
                        color: #4D4D65;
                        display: flex;
                        align-items: center;

                        &:before {
                            display: block;
                            content: '';
                            width: 20px;
                            height: 20px;
                            box-sizing: border-box;
                            border: 2px solid #0263FF;
                            border-radius: 3px;
                            margin-right: 10px;
                        }
                    }

                    &:checked {
                        & + label {

                            &:after {
                                position: absolute;
                                top: 0;
                                left: 5px;
                                display: block;
                                content: url("../assets/img/icons/checkbox-arrow.svg");
                            }
                        }
                    }
                }
            }

            button {
                display: block;
                width: 179px;
                height: 38px;
                border-radius: 19px;
                background-color: #0263FF;
                color: #ffffff;
                font-family: $mainFont, sans-serif;
                font-size: 18px;
                font-weight: 700;
                letter-spacing: 0.58px;
                margin: 85px auto 0 auto;
                border: 0;

                &:hover {
                    cursor: pointer;
                }
            }
        }

        .skip-offer {
            display: table;
            font-family: $mainFont, sans-serif;
            font-weight: 700;
            font-size: 14px;
            color: #0263FF;
            letter-spacing: .86px;
            margin: 90px auto 0 auto;
            border: 0;
            background: transparent;

            &:hover {
                cursor: pointer;
            }
        }
    }
</style>
